"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_svg_1 = __importStar(require("react-native-svg"));
const PathBuilder_1 = __importDefault(require("./lib/PathBuilder"));
class ClipRect extends react_1.PureComponent {
    render() {
        const style = react_native_1.StyleSheet.flatten(this.props.style);
        let { width, height, borderRadius, borderTopLeftRadius, borderTopRightRadius, borderBottomRightRadius, borderBottomLeftRadius, color, } = style;
        borderRadius = borderRadius || 0;
        if (borderRadius > Math.min(width, height) / 2) {
            borderRadius = Math.min(width, height) / 2;
        }
        const tl = borderTopLeftRadius || borderRadius;
        const tr = borderTopRightRadius || borderRadius;
        const br = borderBottomRightRadius || borderRadius;
        const bl = borderBottomLeftRadius || borderRadius;
        const path = new PathBuilder_1.default();
        path.move(tl, 0);
        path.lineTo(width - tr, 0);
        if (tr) {
            path.arc(width - tr, tr, tr, 0);
        }
        path.move(tr, tr);
        path.lineTo(width, height - br);
        if (br) {
            path.arc(width - br, height - br, br, 1);
        }
        path.move(-br, br);
        path.lineTo(bl, height);
        if (bl) {
            path.arc(bl, height - bl, bl, 2);
        }
        path.move(-bl, -bl);
        path.lineTo(0, tr);
        if (tl) {
            path.arc(tr, tr, tr, 3);
        }
        path.move(tr, -tr);
        path
            .lineTo(width - tr, 0)
            .lineTo(width, tr)
            .lineTo(width, height - br)
            .lineTo(width - br, height)
            .lineTo(bl, height)
            .lineTo(0, height - bl)
            .lineTo(0, bl);
        path.close();
        return (react_1.default.createElement(react_native_svg_1.default, { width: width, height: height, style: { backgroundColor: "transparent" }, clipPath: "url(#clip)" },
            react_1.default.createElement(react_native_svg_1.Defs, null,
                react_1.default.createElement(react_native_svg_1.ClipPath, { id: "clip", clipRule: "evenodd" },
                    react_1.default.createElement(react_native_svg_1.Rect, { width: "100%", height: "100%" }),
                    react_1.default.createElement(react_native_svg_1.Path, { fill: "black", d: path.path }))),
            react_1.default.createElement(react_native_svg_1.Rect, { fill: color, clipRule: "evenodd", clipPath: "url(#clip)", width: "100%", height: "100%", x: "0", y: "0" })));
    }
}
exports.default = ClipRect;
